/* bin2h */
/* converts binary file into C header */
/* 2005 Fosters */

#include <stdio.h>
#include <stdlib.h>

#define NUMBERS_PER_LINE 15

int main (int argc, char*argv[]) {
    FILE *ifp, *ofp;
    char *symbol;
    int size=0;
    int i;


    if (argc < 4) {
       printf("Usage:\n");
       printf("%s infile outfile symbol\n",argv[0]);
       exit(1);
    }
    symbol=argv[3];
    
    if ((ifp=fopen(argv[1],"rb"))==NULL) {
       printf("Error: Couldn't open %s for reading\n",argv[1]);
       return 1;
    }
    
    if ((ofp=fopen(argv[2],"w"))==NULL) {
       fclose(ifp);
       printf("Error: Couldn't open %s for writing\n",argv[2]);
       return 1;
    }
    
    fseek(ifp,0L,SEEK_END);
    size=ftell(ifp);
    fseek(ifp,0L,SEEK_SET);
    
    fprintf(ofp,"/* %s */\n",argv[1]);
    fprintf(ofp,"#ifndef _%s_H_\n",symbol);
    fprintf(ofp,"#define _%s_H_\n\n", symbol);
    
    fprintf(ofp,"static char %s[%d] = {\n    ",symbol,size);
    for (i=0; i<size; i++) {
        fprintf(ofp,"0x%02x,",fgetc(ifp));
        if (((i+1) % NUMBERS_PER_LINE) == 0) {
            fprintf(ofp,"\n    ");
        }
    }
    fprintf(ofp,"\n};\n");
    
    fprintf(ofp,"#endif /* _%s_H_ */\n",symbol);
    fclose(ifp);
    fclose(ofp);
    return 0;
}
