/**
 * PACIFI3D main header file
 **
 * 2005 Fosters
 */

#ifndef PACIFI3D_H
#define PACIFI3D_H

#include "SDL.h"
#include <stdlib.h>
#include <string.h>

#include "rom.h"
#include "video.h"
#include "input.h"
#include "memory.h"

#define FPS 60.606060
#define REFRESHTIME 1000/FPS
#define Z80_VBL_CYCLES 3072000/FPS

/*-- Version, date & time to display on startup ----------------------------*/
#ifndef VERSION1
#define VERSION1 "PACIFI3D"
#endif
#define VERSION2 "Compiled on: "__DATE__" "__TIME__

/*-- functions -------------------------------------------------------------*/

void pacman_reset(void);
void pacman_shutdown(void);
void set_interrupt_vector(int);

void sound_init(void);
void sound_stop(void);
void sound_update(void);
void sound_toggle(void);
int sound_write(Uint8 *data, int count);

#endif /* PACIFI3D_H */
