/*******************************************
**** VIDEO.H - Video Hardware Emulation ****
****            Header File             ****
*******************************************/

#ifndef	VIDEO_H
#define VIDEO_H

#include "SDL.h"
#include "SDL_opengl.h"

/*-- Global Variables ------------------------------------------------------*/

/*-- video.c functions ----------------------------------------------------*/
int  video_init(void);
void video_shutdown(void);
int  video_set_mode(int);
void video_draw_screen(void);
void video_save_snapshot(void);
void video_setup(void);
void setup_opengl( int width, int height );
void video_fullscreen_toggle(void);
void video_mode_toggle(void);
void video_mouse_rot(Sint16 xrel, Sint16 yrel);
void video_inc_tile(void);
void video_dec_tile(void);
void incframeskip(void);

void (*blitter)(void);

extern Uint8 tilerom[0x1000];
extern Uint8 spriterom[0x1000];
extern Uint8 prom[0x120];

enum views {CLASSIC, THIRD_PERSON, FIRST_PERSON, CHASE_VIEW, MAX_VIEWS};


static const GLfloat flipxmatrix[16] = {
    -1.0, 0.0, 0.0, 0.0,
     0.0, 1.0, 0.0, 0.0,
     0.0, 0.0, 1.0, 0.0,
     0.0, 0.0, 0.0, 1.0
};

static const GLfloat flipymatrix[16] = {
     1.0, 0.0, 0.0, 0.0,
     0.0,-1.0, 0.0, 0.0,
     0.0, 0.0, 1.0, 0.0,
     0.0, 0.0, 0.0, 1.0
};

#define FLIPX    (glMultMatrixf(flipxmatrix))
#define FLIPY    (glMultMatrixf(flipymatrix))


#endif /* VIDEO_H */

